from base import ConverterBase

import os, tempfile, re

# wv config file (wvZope.xml) is in same directory as this module.
WV_CONFIG = os.path.join(
	os.getcwd(), os.path.dirname(__file__), 'wvZope.xml')

mime_type = 'application/msword'

class Converter(ConverterBase):
	def __init__(self, name, data):
		ConverterBase.__init__(self, name, data)

		self.tmpdir = tempfile.mktemp()
		os.mkdir('%s' % self.tmpdir)

		fd = open("%s/%s.doc" % (self.tmpdir, self.name), "w")
		fd.write(self.data)
		fd.close()

		self._convert()

	def __del__(self):
		for fn in os.listdir("%s" % self.tmpdir):
			os.remove("%s/%s" % (self.tmpdir, fn))
		os.rmdir("%s" % self.tmpdir)

	def _convert(self):
		cmd = "cd '%s' && wvWare -x %s '%s.doc' > '%s.html' 2> /dev/null" \
			% (self.tmpdir, WV_CONFIG, self.name, self.name)
		os.system(cmd)
		cmd = "cd '%s' && wvText '%s.doc' '%s.txt' 2> /dev/null" \
			% (self.tmpdir, self.name, self.name)
		os.system(cmd)

	#
	# Accessors to get results.
	#
	def getText(self):
		return open("%s/%s.txt" % (self.tmpdir, self.name)).read()

	def getHtml(self):
		return open("%s/%s.html" % (self.tmpdir, self.name)).read()

	def getImageNames(self):
		image_names = []
		for fn in os.listdir(self.tmpdir):
			m = re.match("^.+\.(?P<ext>.+)$", fn)
			if m and m.group(1) in ('png', 'jpg', 'gif', 'wmz', 'wmf'):
				image_names.append(fn)
		return image_names

	def getImage(self, image_name):
		return open("%s/%s" % (self.tmpdir, image_name)).read()


#class MSWord(DocumentContentBase):
#	
#	def __init__(self, name=''):
#		self.name = name
#		self.images = {}
#
#	def edit(self, data):
#		self._data = data
#
#	def asText(self):
#		return self._text
#
#	def asHtml(self):
#		return self._html
#
#	def edit(self, data=''):
#		self._data = data
#
#		converter = WordConverter(self.name, self._data)
#		self._html = converter.getHtml()
#		self._text = converter.getText()
#		for image_name in converter.getImageNames():
#			self.images[image_name] = converter.getImage(image_name)
#		self.images = self.images


# vim:ts=2
