#!/usr/local/bin/python

import sys, os, unittest
sys.path.insert(0, '..')
sys.path.insert(0, os.environ.get('ZOPE_HOME')+'/lib/python/')
import Zope
import plugins, string

class ConverterTestCase(unittest.TestCase):

  def test_Base(self):
    doc = plugins.base.ConverterBase('toto', 'titi')

    self.assertEquals(doc.getRaw(), 'titi')
    self.assertEquals(doc.getHtml(), '')
    self.assertEquals(doc.getText(), '')
    self.assertEquals(doc.getImageNames(), [])
    self.assertRaises(KeyError, doc.getImage, '')

  
  #def test_Inert(self):
  #  doc = plugins.Inert.Inert()
  #  doc.edit('toto')
#
#    self.assertEquals(doc._data, 'toto')
#    self.assertEquals(doc.mime_type, '???/???') # XXX: fix this

  def loadMSWordFile(self, name):
    self.doc = plugins.MSWord.MSWordConverter(
      name, open('%s.doc' % name).read())

  def checkWordContent(self):
    self.assertEquals(
    	string.count(self.doc.getHtml(), 'Linux rulez. Window$ SuCk$$$.'), 1)
    self.assertEquals(
    	string.count(self.doc.getText(), 'Linux rulez. Window$ SuCk$$$.'), 1)

  def test_MSWord1(self):
    self.loadMSWordFile('test1')
    self.checkWordContent()

  def test_MSWord2(self):
    self.loadMSWordFile('test2')
    self.checkWordContent()

  def test_MSWord3(self):
    self.loadMSWordFile('test3')
    self.checkWordContent()

  def test_MSWord4(self):
    self.loadMSWordFile('test4')
    self.checkWordContent()

    images_names = self.doc.getImageNames()
    self.assertEquals(len(images_names), 1)
    self.assertEquals(images_names[0], 'test40.png')
    self.assertEquals(len(self.doc.getImage('test40.png')), 5690)

if __name__ == '__main__':
  unittest.main()

